/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilit dportes      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

jsLoader.loadSubScript("chrome://opensi/content/libs/util.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/query.js");

/**
 * @classDescription    Une classe reprsentant un prospect
 * @constructor
 * @return {Object} un objet Prospect initialis  vide
 */
function Prospect () {}

Prospect.prototype = {
    Id_Prospect: "",
    Civilite: 0,
    Nom: '',
    Prenom: '',
    Raison_Sociale: "",
    Adresse: '',
    Comp_Adresse: '',
    Code_Postal: '',
    Ville: '',
    Tel: '',
    Mobile: '',
    Fax: '',
    Email: '',
    Site_Web: '',
    Date_Recontact: 0,
    Date_Rdv: 0,
    A_Rappeler: 0,
    Demande_Plaquette: 0,
    Etat: 0,
    Mailing: 0,
    Id_Valeur_Prospect:1,
    Divers: '',
    Mode: 'N', // mode nouveau / mise  jour
    Interet: 0,
    Commentaire_Communication: '',
    
    enregistrer: function() {
        var req_enregistrement = new QueryHttp("CRM/Prospects/enregistrerProspect.tmpl");
        req_enregistrement.setParam("Id_Prospect", this.Id_Prospect);
        req_enregistrement.setParam("Civilite", this.Civilite);
        req_enregistrement.setParam("Nom", this.Nom);
        req_enregistrement.setParam("Prenom", this.Prenom);
        req_enregistrement.setParam("Raison_Sociale", this.Raison_Sociale);
        req_enregistrement.setParam("Adresse", this.Adresse);
        req_enregistrement.setParam("Comp_Adresse", this.Comp_Adresse);
        req_enregistrement.setParam("Code_Postal", this.Code_Postal);
        req_enregistrement.setParam("Ville", this.Ville);
        req_enregistrement.setParam("Tel", this.Tel);
        req_enregistrement.setParam("Mobile", this.Mobile);
        req_enregistrement.setParam("Fax", this.Fax);
        req_enregistrement.setParam("Email", this.Email);
        req_enregistrement.setParam("Site_Web", this.Site_Web);
        req_enregistrement.setParam("Date_Recontact",
                                    this.Date_Recontact == 0 ? 0 : prepareDateHeureJava(this.Date_Recontact));
        req_enregistrement.setParam("Date_Rdv",
                                     this.Date_Rdv == 0 ? 0 : prepareDateHeureJava(this.Date_Rdv));
        req_enregistrement.setParam("A_Rappeler", this.A_Rappeler);
        req_enregistrement.setParam("Demande_Plaquette", this.Demande_Plaquette);
        req_enregistrement.setParam("Etat", this.Etat);
        req_enregistrement.setParam("Mailing", this.Mailing);
        req_enregistrement.setParam("Divers", this.Divers);
        req_enregistrement.setParam("Id_Valeur_Prospect", this.Id_Valeur_Prospect);
        req_enregistrement.setParam("Commentaire_Communication", this.Commentaire_Communication);
        req_enregistrement.setParam("Mode", this.Mode);
        var req = req_enregistrement.execute();
        return req;
    },
    
    supprimer: function() {
        var req_suppression = new QueryHttp("CRM/Prospects/supprimerProspect.tmpl");
        req_suppression.setParam("Id_Prospect", this.Id_Prospect);
        var req = req_suppression.execute();
        return req;
    },
    
    passerEnClient: function() {
        var req_passage = new QueryHttp("CRM/Prospects/passerEnClient.tmpl");
        req_passage.setParam("Client_Id", this.Id_Prospect);
        req_passage.setParam("Civilite", this.Civilite);
        req_passage.setParam("Nom", this.Nom);
        req_passage.setParam("Prenom", this.Prenom);
        req_passage.setParam("Raison_Sociale", this.Raison_Sociale);
        req_passage.setParam("Adresse", this.Adresse);
        req_passage.setParam("Comp_Adresse", this.Comp_Adresse);
        req_passage.setParam("Adresse_3", "");
        req_passage.setParam("Code_Postal", this.Code_Postal);
        req_passage.setParam("Ville", this.Ville);
        req_passage.setParam("Pays", "France");
        req_passage.setParam("Tel", this.Tel);
        req_passage.setParam("Mobile", this.Mobile);
        req_passage.setParam("Fax", this.Fax);
        req_passage.setParam("Email", this.Email);
        req_passage.setParam("Mailing", this.Mailing);
        req_passage.setParam("Site_Web", this.Site_Web);
        var req = req_passage.execute();
        return req;
    },
    
    selectionner: function() {
        var req_selection = new QueryHttp("CRM/Prospects/selectionnerProspect.tmpl");
        req_selection.setParam("Id_Prospect", this.Id_Prospect);
        var req = req_selection.execute();
        return req;
    },
    
    selectionnerSuivant: function() {
        var req_selection = new QueryHttp("CRM/Prospects/selectionnerProspectSuivant.tmpl");
        req_selection.setParam("Id_Prospect", this.Id_Prospect);
        req_selection.setParam("Etat", this.Etat);
        req_selection.setParam("Interet", this.Interet);
        req_selection.setParam("Id_Valeur_Prospect", this.Id_Valeur_Prospect);
        req_selection.setParam("Raison_Sociale", this.Raison_Sociale);
        var req = req_selection.execute();
        return req;
    },
    
    /**
     * Vrifier les paramtres
     * 
     * @exception {DateFormatException} si une date est invalide
     */
    verifier: function() {
        if ((this.Date_Rdv != 0 && !isDateHeure(this.Date_Rdv)) ||
            (this.Date_Recontact != 0 && !isDateHeure(this.Date_Recontact)))
            throw "DateFormatException";
        
    },
    
    setDefauts: function() {
        this.Id_Prospect = "";
        this.Civilite = 0;
        this.Nom = '';
        this.Prenom = '';
        this.Raison_Sociale = "";
        this.Adresse = '';
        this.Comp_Adresse = '';
        this.Code_Postal = '';
        this.Ville = '';
        this.Tel = '';
        this.Mobile = '';
        this.Fax = '';
        this.Email =  '';
        this.Site_Web = '';
        this.Date_Recontact = 0;
        this.Date_Rdv = 0;
        this.A_Rappeler = 0;
        this.Demande_Plaquette = 0;
        this.Etat = 0;
        this.Mailing = 0;
        this.Divers = '';
        this.Id_Valeur_Prospect = 1;
        this.Mode = 'N';
        this.Interet = 0;
        this.Commentaire_Communication = '';
    },
    
    getAttribute: function(attr) {
        try {
            return eval("this." + attr);
        } catch (e) {
            return "";
        } 
    }
    
}
