/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


jsLoader.loadSubScript("chrome://opensi/content/libs/arbres.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/formatter.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/lib_tva.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/query.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/verif.js");

var devis_id;
var mode_ligne;
var mode;
var etat_devis;
var mode_tarif;
var initLigne = false;
var currentRank = 0;
var type_remise = 'P';
var editionTTC = false;
var assujettiTVA = false;
var tva_port;
var currentTotalHT = 0;
var currentMontantTTC = 0;
var zoneUE=false;
var charger = true;


var nf = new NumberFormat("0.00", false);

function init() {
  try {
    
  	var qParam = new QueryHttp("Config/gestion_commerciale/preferences/getParam.tmpl");
		var result = qParam.execute();
		
		var act_code_stats = (parseInt(result.responseXML.documentElement.getAttribute('Act_Code_Stats'))==1);
		var produit_frais = (parseInt(result.responseXML.documentElement.getAttribute('Produit_Frais'))==1);
		if (!act_code_stats) {
			document.getElementById('ColCode_Stats').collapsed = true;
	  	document.getElementById('Act_Code_Stats').collapsed = true;
		} else {
			document.getElementById('labelRef').setAttribute('style', 'margin-left:0px');
			document.getElementById('Reference').setAttribute('style', 'margin-left:0px');
		}
		
		if (!produit_frais) {
			document.getElementById('ColNum_Lot').collapsed = true;
			document.getElementById('ColNb_Pieces').collapsed = true;
			document.getElementById('ColUnite').collapsed = true;
			document.getElementById('ColDate_Peremption').collapsed = true;
			document.getElementById('Produit_Frais_1').collapsed = true;
			document.getElementById('Produit_Frais_2').collapsed = true;
			document.getElementById('Produit_Frais_3').collapsed = true;
			document.getElementById('Produit_Frais_4').collapsed = true;
		}
		
		var aCodesTarifs = new Arbre("fact", "liste_types_tarifs.tmpl", "Code_Tarif");
		aCodesTarifs.initTree(initCodeTarif);

		setModeTarif();
		
		// liste des units de l'article
		var aUnite = new Arbre("fact", "unites_vente.tmpl", "Unite");
		aUnite.initTree(initUnite);
		
		var aPays = new Arbre("fact", "liste_pays.tmpl", "Code_Pays_Fact");
		aPays.initTree(initPaysFact);
		
		document.getElementById('poidsTotal').value = 0;

	} catch (e) {
  	recup_erreur(e);
	}
}

function initCodeTarif() {
	try {
		document.getElementById('Code_Tarif').selectedIndex=0;
	} catch (e) {
		recup_erreur(e);
	}
}

function initUnite() {
	try {

    document.getElementById('Unite').selectedIndex = 0;

	} catch (e) {
    recup_erreur(e);
  }
}

function initPaysFact() {
	try {
    
    var aPaysLiv = new Arbre("fact", "liste_pays.tmpl", "Code_Pays_Liv");
		aPaysLiv.initTree(initPaysLiv);

	} catch (e) {
    recup_erreur(e);
  }
}


function initPaysLiv() {
	try {

    var paramlist = "&Page=Facturation/GetRDF/liste_commerciaux.tmpl&ContentType=xml";
  	load_rdf_async('Login_Resp', getUrlOpeneas(paramlist), initResp);

	} catch (e) {
    recup_erreur(e);
  }
}


function initResp() {
  try {

		document.getElementById('Login_Resp').value = get_cookie("User");

		window.parent.addEventListener("close",demandeEnregistrement,false);

		mode = ParamValeur("Mode");

		if (mode=="C") {
			nouveauDevis();
		}
		else {

			// chargement

			devis_id = ParamValeur("Devis_Id");

			initLigne = true;

			init_tree();
			
			var queryLoadTemp = new QueryHttp("Facturation/Devis/loadArticleDevisTemp.tmpl");
			queryLoadTemp.setParam("Devis_Id", devis_id);
			queryLoadTemp.execute();
			
			calculerPoids();
		}

	} catch (e) {
  	recup_erreur(e);
	}
}



function selectPaysLiv() {
	try {
		if (charger) {
			listeTVA();
		}
    changerTypeVente();
	} catch (e) {
		recup_erreur(e);
	}
}


function listeTVA() {
  try {
  	tva_port = getTvaNormal(document.getElementById("Code_Pays_Liv").value,assujettiTVA,document.getElementById("Regime_TVA").value);
  	calculTotaux();
    var aCode = new Arbre("fact", "taux_tva.tmpl", "Code_TVA");
    aCode.setParam("Code_Pays", document.getElementById("Code_Pays_Liv").value);
    aCode.setParam("Regime_TVA", document.getElementById("Regime_TVA").value);
    aCode.setParam("Assujetti_TVA", assujettiTVA?"1":"0");
    aCode.initTree(selectTVA); 
  } catch (e) {
    recup_erreur(e);
  }
}

 function selectTVA() {
  try {
    document.getElementById('Code_TVA').value = getCodeTvaNormal(document.getElementById('Code_Pays_Liv').value,assujettiTVA,document.getElementById("Regime_TVA").value);
  } catch (e) {
    recup_erreur(e);
  }
}

function setModeTarif() {
	try {

    var corps = cookie() +"&Page=Config/gestion_commerciale/preferences/getParam.tmpl&ContentType=xml";
    var p = requeteHTTP(corps);

		mode_tarif = p.responseXML.documentElement.getAttribute('Mode_Tarif');

		if (mode_tarif=='Q') {
			document.getElementById('row_tarif').collapsed = true;
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function desinit() {
	try {

		window.parent.removeEventListener("close",demandeEnregistrement,false);

	} catch (e) {
    recup_erreur(e);
  }
}


function switchRemise() {
	try {

		if (type_remise=='P') {
			document.getElementById('bRemise').setAttribute("label", "\u20AC");
			type_remise = 'M';
		}
		else {
			document.getElementById('bRemise').setAttribute("label", "%");
			type_remise = 'P';
		}
		calculTotaux();
		setModifie(true);

	} catch (e) {
    recup_erreur(e);
  }
}


function afficherFichiers() {
	try {
	
    var ok = true;
		if (mode=="C") {
			ok = enregistrerDevis();
		}

		if (ok) {
  	  var url = "chrome://opensi/content/facturation/user/recherches/rech_fichiers.xul?"+ cookie() +"&Type=Devis&Document_Id="+ urlEncode(devis_id);
    	window.openDialog(url,'','chrome,modal,centerscreen');
    }
		
	} catch (e) {
    recup_erreur(e);
  }
}


function disableAll() {
	try {

		mode = "V";

		document.getElementById('Commentaires').disabled = true;		
		document.getElementById('Imp_Com').disabled = true;
		document.getElementById('bChoisirMentions').disabled = true;
		document.getElementById('Remise').disabled = true;
		document.getElementById('Escompte').disabled = true;
		document.getElementById('Acompte').disabled = true;
		document.getElementById('Frais_Port').disabled = true;
		document.getElementById('Date_Exp').disabled = true;

		document.getElementById('Login_Resp').disabled = true;

		document.getElementById('Denomination_Fact').disabled = true;
		document.getElementById('Adresse_1_Fact').disabled = true;
		document.getElementById('Adresse_2_Fact').disabled = true;
		document.getElementById('Adresse_3_Fact').disabled = true;
		document.getElementById('Code_Postal_Fact').disabled = true;
		document.getElementById('Ville_Fact').disabled = true;
		document.getElementById('Code_Pays_Fact').disabled = true;

		document.getElementById('Civ_Inter_Fact').disabled = true;
		document.getElementById('Nom_Inter_Fact').disabled = true;
		document.getElementById('Prenom_Inter_Fact').disabled = true;
		document.getElementById('Tel_Inter_Fact').disabled = true;
		document.getElementById('Fax_Inter_Fact').disabled = true;
		document.getElementById('Email_Inter_Fact').disabled = true;
		
		document.getElementById('Denomination_Liv').disabled = true;
		document.getElementById('Adresse_1_Liv').disabled = true;
		document.getElementById('Adresse_2_Liv').disabled = true;
		document.getElementById('Adresse_3_Liv').disabled = true;
		document.getElementById('Code_Postal_Liv').disabled = true;
		document.getElementById('Ville_Liv').disabled = true;
		document.getElementById('Code_Pays_Liv').disabled = true;

		document.getElementById('Civ_Inter_Liv').disabled = true;
		document.getElementById('Nom_Inter_Liv').disabled = true;
		document.getElementById('Prenom_Inter_Liv').disabled = true;
		document.getElementById('Tel_Inter_Liv').disabled = true;
		document.getElementById('Fax_Inter_Liv').disabled = true;
		document.getElementById('Email_Inter_Liv').disabled = true;

		document.getElementById('bCommentaire').disabled = true;
		document.getElementById('bArticle').disabled = true;
		document.getElementById('bEnregistrer').disabled = true;
		document.getElementById('bProforma').disabled = true;
		document.getElementById('bSupDevis').disabled = (etat_devis=='F' || etat_devis=='A' || etat_devis=='C');
		document.getElementById('bTransFac').disabled = true;
		document.getElementById('bTransAff').disabled = true;
		document.getElementById('bTransCom').disabled = true;
		document.getElementById('bRemise').disabled = true;
		document.getElementById('Edition_TTC').disabled = true;
		document.getElementById('Assujetti_TVA').disabled = true;
		document.getElementById('Num_TVA').disabled = true;
		document.getElementById('Regime_TVA').disabled = true;
		document.getElementById('chercher_client').disabled = true;
		document.getElementById('chercher_adrfact').disabled = true;
		document.getElementById('chercher_inter').disabled = true;
		document.getElementById('chercher_adrliv').disabled = true;
		document.getElementById('chercher_inter_liv').disabled = true;
		document.getElementById('bCopierFactVersLiv').disabled = true;

		formatLigne("");

	} catch (e) {
    recup_erreur(e);
  }
}


function ajouterLigne(type_ligne) {
  try {

		document.getElementById('bSupprimer').disabled = true;
		mode_ligne = "C";

		document.getElementById("Type_Ligne").value = type_ligne;

		formatLigne(type_ligne);

		switch(type_ligne) {
			case "S":

				var reference = document.getElementById("Reference").value;

				if (!isEmpty(reference)) {

					if (mode_tarif=='Q') {

						var url = "chrome://opensi/content/facturation/user/commun/popup-choixTarif.xul?"+ cookie() +"&Article_Id="+ urlEncode(reference);
    				window.openDialog(url,'','chrome,modal,centerscreen', reporterTarifId);

						var tarif_id = document.getElementById('Tarif_Id').value;

						if (!isEmpty(tarif_id)) {

							var corps = cookie() +"&Page=Facturation/Affaires/getArticleQte.tmpl&ContentType=xml&Article_Id="+ urlEncode(reference);
							corps += "&Tarif_Id="+ tarif_id;
							corps += "&Type_Prix="+ (editionTTC?"TTC":"HT");

							var p = requeteHTTP(corps);

							var contenu = p.responseXML.documentElement;

							document.getElementById("Code_Stats").value = contenu.getAttribute("Code_Stats");
							document.getElementById("Designation").value = contenu.getAttribute("Designation");
							document.getElementById("Num_Lot").value = "";
							document.getElementById("Nb_Pieces").value = "";
							document.getElementById('Quantite').value = contenu.getAttribute("Quantite");
							document.getElementById('Unite').value = contenu.getAttribute("Unite");
							document.getElementById("Date_Peremption").value = "";
							document.getElementById("PU").value = contenu.getAttribute("Prix");
							document.getElementById('Ristourne').value = "0.00";
							document.getElementById("Code_TVA").value = getCodeTvaCorrespondant(contenu.getAttribute("Code_TVA"),document.getElementById('Code_Pays_Liv').value,assujettiTVA,document.getElementById('Regime_TVA').value);
							document.getElementById("Tarif_Id").value = "";
							document.getElementById("Libelle").value = contenu.getAttribute("Libelle");
						}
						else {
							ajouterLigne("I");
						}
					}
					else {
						var corps = cookie() +"&Page=Facturation/Affaires/getArticleTarif.tmpl&ContentType=xml&Article_Id="+ urlEncode(reference) +"&Code_Tarif="+ document.getElementById('Code_Tarif').value;
						var client_id = document.getElementById("Client_Id").value;
						if (!isEmpty(client_id)) {
							corps += "&Client_Id="+ urlEncode(client_id);
						}
						corps += "&Type_Prix="+ (editionTTC?"TTC":"HT");

						var p = requeteHTTP(corps);

						var contenu = p.responseXML.documentElement;

						document.getElementById("Code_Stats").value = contenu.getAttribute("Code_Stats");
						document.getElementById("Designation").value = contenu.getAttribute("Designation");
						document.getElementById("Num_Lot").value = "";
						document.getElementById("Nb_Pieces").value = "";
						document.getElementById('Quantite').value = 1;
						document.getElementById('Unite').value = contenu.getAttribute("Unite");
						document.getElementById("Date_Peremption").value = "";
						document.getElementById("PU").value = contenu.getAttribute("Prix");
						document.getElementById('Ristourne').value = "0.00";
						document.getElementById("Code_TVA").value = getCodeTvaCorrespondant(contenu.getAttribute("Code_TVA"),document.getElementById('Code_Pays_Liv').value,assujettiTVA,document.getElementById('Regime_TVA').value);
						document.getElementById("Libelle").value = "";
					}
				}
				else {
					ajouterLigne("I");
				}

				break;

			case "I":

				document.getElementById('Code_Stats').value = "";
				document.getElementById('Reference').value = "";
				document.getElementById('Designation').value = "";
				document.getElementById("Num_Lot").value = "";
				document.getElementById("Nb_Pieces").value = "";
				document.getElementById('Quantite').value = 1;
				document.getElementById('Unite').value = "U";
				document.getElementById("Date_Peremption").value = "";
				document.getElementById('PU').value = "";
				document.getElementById('Ristourne').value = "0.00";
				document.getElementById('Code_TVA').value = getCodeTvaNormal(document.getElementById('Code_Pays_Liv').value,assujettiTVA,document.getElementById('Regime_TVA').value);
				document.getElementById("Libelle").value = "";
				document.getElementById('Reference').focus();
				break;
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function formatLigne(type_ligne) {
  try {

		switch(type_ligne) {
			case "S":
				document.getElementById('Code_Stats').disabled = false;
				document.getElementById('Reference').disabled = true;
				document.getElementById('Designation').disabled = true;
				document.getElementById('Num_Lot').disabled = false;
				document.getElementById('Nb_Pieces').disabled = false;
				document.getElementById('Quantite').disabled = false;
				document.getElementById('Unite').disabled = false;
				document.getElementById('Date_Peremption').disabled = false;
				document.getElementById('PU').disabled = false;
				document.getElementById('Ristourne').disabled = false;
				document.getElementById('Code_TVA').disabled = false;
				document.getElementById('bValider').disabled = false;
				document.getElementById('bAnnuler').disabled = false;
				break;

			case "I":
				document.getElementById('Code_Stats').disabled = false;
				document.getElementById('Reference').disabled = false;
				document.getElementById('Designation').disabled = false;
				document.getElementById('Num_Lot').disabled = false;
				document.getElementById('Nb_Pieces').disabled = false;
				document.getElementById('Quantite').disabled = false;
				document.getElementById('Unite').disabled = false;
				document.getElementById('Date_Peremption').disabled = false;
				document.getElementById('PU').disabled = false;
				document.getElementById('Ristourne').disabled = false;
				document.getElementById('Code_TVA').disabled = false;
				document.getElementById('bValider').disabled = false;
				document.getElementById('bAnnuler').disabled = false;
				break;

			default:
				document.getElementById('Code_Stats').value = "";
				document.getElementById('Reference').value = "";
				document.getElementById('Designation').value = "";
				document.getElementById('Num_Lot').value = "";
				document.getElementById('Nb_Pieces').value = "";
				document.getElementById('Quantite').value = "";
				document.getElementById('Unite').value = "U";
				document.getElementById('Date_Peremption').value = "";
				document.getElementById('PU').value = "";
				document.getElementById('Ristourne').value = "";
				document.getElementById('Libelle').value = "";
				document.getElementById('Code_TVA').value = getCodeTvaNormal(document.getElementById("Code_Pays_Liv").value,assujettiTVA,document.getElementById('Regime_TVA').value);
				document.getElementById('Code_Stats').disabled = true;
				document.getElementById('Reference').disabled = true;
				document.getElementById('Designation').disabled = true;
				document.getElementById('Num_Lot').disabled = true;
				document.getElementById('Nb_Pieces').disabled = true;
				document.getElementById('Quantite').disabled = true;
				document.getElementById('Unite').disabled = true;
				document.getElementById('Date_Peremption').disabled = true;
				document.getElementById('PU').disabled = true;
				document.getElementById('Ristourne').disabled = true;
				document.getElementById('Code_TVA').disabled = true;
				document.getElementById('bSupprimer').disabled = true;
				document.getElementById('bValider').disabled = true;
				document.getElementById('bAnnuler').disabled = true;
				break;
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function pressOnWindow(ev) {
	try {

		if (ev.altKey && mode!="V") {
			switch(ev.charCode) {
      	case 97: // 'a'
					rechercherStock();
        	break;
				case 116: // 't'
					modifierTarif();
					break;
    	}
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function pressOnQuantite(ev) {
	try {
		
		if (ev.keyCode==13) {
			validerLigne();
		}
		
	} catch (e) {
    recup_erreur(e);
  }
}


function pressOnReference(ev) {
	try {

		if (ev.keyCode==13) {
			rechercherReference();
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function rechercherStock() {
	try {

		var url = "chrome://opensi/content/facturation/user/stocks/rech_stocks.xul?"+ cookie();
		if (mode_tarif != "Q") {
			url += "&Code_Tarif=" + document.getElementById('Code_Tarif').value;
		}
    window.openDialog(url,'','chrome,modal,centerscreen',retourRechercherStock);

	} catch (e) {
    recup_erreur(e);
  }
}


function retourRechercherStock(reference) {
	try {
	
		document.getElementById('Reference').value = reference;
		ajouterLigne("S");
	
	} catch (e) {
    recup_erreur(e);
  }
}


function rechercherReference() {
	try {

		var qExArt = new QueryHttp("Facturation/Recherches/rechReference.tmpl");
		qExArt.setFullParamById('Reference');
		var result = qExArt.execute();
		
		var articleId = result.responseXML.documentElement.getAttribute("Article_Id");
		
		if (!isEmpty(articleId)) {
			document.getElementById('Reference').value = articleId;
			ajouterLigne("S");
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function modifierTarif() {
	try {

		if (mode_ligne = "M" && document.getElementById('Type_Ligne').value=='S') {

			if (mode_tarif=='Q') {

				var reference = document.getElementById('Reference').value;

				var url = "chrome://opensi/content/facturation/user/commun/popup-choixTarif.xul?"+ cookie() +"&Article_Id="+ urlEncode(reference);
    		window.openDialog(url,'','chrome,modal,centerscreen', reporterTarifId);

				var tarif_id = document.getElementById('Tarif_Id').value;

				if (!isEmpty(tarif_id)) {

					var corps = cookie() +"&Page=Facturation/Affaires/getArticleQte.tmpl&ContentType=xml&Article_Id="+ urlEncode(reference);
					corps += "&Tarif_Id="+ tarif_id;
					corps += "&Type_Prix="+ (editionTTC?"TTC":"HT");

					var p = requeteHTTP(corps);

					var contenu = p.responseXML.documentElement;

					document.getElementById('Quantite').value = contenu.getAttribute("Quantite");
					document.getElementById('Unite').value = contenu.getAttribute("Unite");
					document.getElementById("PU").value = contenu.getAttribute("Prix");
					document.getElementById("Tarif_Id").value = "";
					document.getElementById("Libelle").value = contenu.getAttribute("Libelle");
				}
			}
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function reporterTarifId(tarif_id) {
	try {
		document.getElementById('Tarif_Id').value = tarif_id;
	} catch (e) {
		recup_erreur(e);
	}
}


function ouvrirLigne() {
  try {

		var tree = document.getElementById("articles");

		if (tree.view!=null && tree.currentIndex!=-1 && mode=="M") {

			if (getCellText(tree,tree.currentIndex,'ColType_Ligne')=="C") {
				ajouterLigne("I");
			}
			else {
				mode_ligne = "M";
				document.getElementById('bSupprimer').disabled = false;

				document.getElementById("Code_Stats").value = getCellText(tree,tree.currentIndex,'ColCode_Stats');
				document.getElementById("Reference").value = getCellText(tree,tree.currentIndex,'ColReference');
				document.getElementById("Designation").value = getCellText(tree,tree.currentIndex,'ColDesignation');
				document.getElementById("Num_Lot").value = getCellText(tree,tree.currentIndex,'ColNum_Lot');
				document.getElementById("Nb_Pieces").value = getCellText(tree,tree.currentIndex,'ColNb_Pieces');
				document.getElementById("Quantite").value = getCellText(tree,tree.currentIndex,'ColQuantite');
				document.getElementById("Unite").value = getCellText(tree,tree.currentIndex,'ColUnite');
				document.getElementById("Date_Peremption").value = getCellText(tree,tree.currentIndex,'ColDate_Peremption');
				document.getElementById("PU").value = getCellText(tree,tree.currentIndex,'ColPU');
				document.getElementById("Code_TVA").value = getCellText(tree,tree.currentIndex,'ColCode_TVA');
				document.getElementById("Ristourne").value = getCellText(tree,tree.currentIndex,'ColRistourne');
				document.getElementById("Type_Ligne").value = getCellText(tree,tree.currentIndex,'ColType_Ligne');
				document.getElementById("Rank").value = getCellText(tree,tree.currentIndex,'ColRank');
				document.getElementById("Libelle").value = getCellText(tree,tree.currentIndex,'ColLibelle');

				formatLigne(document.getElementById("Type_Ligne").value);
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function ouvrirCommentaire() {
  try {

		var tree = document.getElementById("articles");

		if (tree.view!=null && tree.currentIndex!=-1 && mode=="M") {

			if (getCellText(tree,tree.currentIndex,'ColType_Ligne')=="C") {
				editerCommentaire();
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function validerLigne() {
  try {

		var type_ligne = document.getElementById("Type_Ligne").value;
		var code_stats = document.getElementById("Code_Stats").value;
		var reference = document.getElementById("Reference").value;
		var designation = document.getElementById("Designation").value;
		var num_lot = document.getElementById("Num_Lot").value;
		var nb_pieces = document.getElementById("Nb_Pieces").value;
		var quantite = document.getElementById("Quantite").value;
		var unite = document.getElementById("Unite").value;
		var date_peremption = document.getElementById("Date_Peremption").value;
		var pu = document.getElementById("PU").value;
		var ristourne = document.getElementById("Ristourne").value;
		var code_tva = document.getElementById("Code_TVA").value;
		var rank = document.getElementById("Rank").value;
		var libelle = document.getElementById("Libelle").value;
		var ok = true;

		if (mode=="C") {
			ok = enregistrerDevis();
		}

		if (ok) {

			if (mode_ligne=="C") {
				var corps = cookie() +"&Page=Facturation/Devis/ajouterArticle.tmpl&ContentType=xml";
			}
			else {
				var corps = cookie() +"&Page=Facturation/Devis/modifierArticle.tmpl&ContentType=xml";
			}

			corps += "&Reference="+ urlEncode(reference) +"&Designation="+ urlEncode(designation) + "&Num_Lot=" + urlEncode(num_lot) + "&Nb_Pieces=" + nb_pieces +"&Quantite="+ quantite +"&Unite="+ urlEncode(unite) +"&Type_Ligne="+ type_ligne;
			corps += "&Prix="+ pu +"&Ristourne="+ ristourne +"&Code_TVA="+ code_tva +"&Devis_Id="+ devis_id +"&Rank="+ rank +"&Libelle="+ urlEncode(libelle);
			corps += "&Code_Stats=" + code_stats;

			if (isEmpty(designation)) { showWarning("Dsignation de l'article manquante !"); }
			else if (!checkQte(quantite)) { showWarning("Quantit incorrecte !");	}
			else if (!isEmpty(nb_pieces) && !isPositiveInteger(nb_pieces)) { showWarning("Nombre de pices incorrect !");	}
			else if (!isEmpty(date_peremption) && !isDate(date_peremption)) { showWarning("Date de premption incorrecte !");	}
			else if (isEmpty(pu) || !isPositiveOrNull(pu) || !checkDecimal(pu,4)) { showWarning("Prix unitaire incorrect !");	}
			else if (isEmpty(ristourne) || !isTaux(ristourne)) { showWarning("Taux de ristourne incorrect !");	}
			else {
				
				corps += "&Date_Peremption=" + (!isEmpty(date_peremption)?prepareDateJava(date_peremption):"");
				var p = requeteHTTP(corps);

				currentRank = p.responseXML.documentElement.getAttribute('Rank');
				ajouterLigne("I");
				delete_tree();
				init_tree_temp();
				setModifie(true);
				
				if (type_ligne=='S') {
					calculerPoids();
				}
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function annulerLigne() {
  try {

		ajouterLigne("I");

	} catch (e) {
  	recup_erreur(e);
	}
}


function supprimerLigne() {
  try {

		var rank = document.getElementById("Rank").value;

		var corps = cookie() +"&Page=Facturation/Devis/supprimerArticle.tmpl&ContentType=xml&Devis_Id="+ devis_id +"&Rank="+ rank;
		requeteHTTP(corps);

		currentRank = rank;
		ajouterLigne("I");
		delete_tree();
		init_tree_temp();
		setModifie(true);
		
		calculerPoids();

	} catch (e) {
  	recup_erreur(e);
	}
}


function supprimerDevis() {
  try {

		if (window.confirm("Confirmez-vous la suppression du devis ?")) {

			var corps = cookie() +"&Page=Facturation/Devis/supprimerDevis.tmpl&ContentType=xml&Devis_Id="+ devis_id;
			requeteHTTP(corps);

			showMessage("Le devis a t supprim !");
			retour_devis();
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function transAffaire() {
  try {

		var tree = document.getElementById("articles");

		if (tree.view==null || tree.view.rowCount<=0) {
			showWarning("Le devis ne contient aucune ligne !");
		}
		else {
			if (window.confirm("Etes-vous sr de vouloir passer le devis en affaire ?")) {
				var corps = cookie() +"&Page=Facturation/Devis/transDevisAffaire.tmpl&ContentType=xml&Devis_Id="+ devis_id;
				var p = requeteHTTP(corps);

				var affaire_id = p.responseXML.documentElement.getAttribute("Affaire_Id");

				var page = "chrome://opensi/content/facturation/user/affaires/fiche_affaire.xul?"+ cookie() +"&Affaire_Id="+ affaire_id;
    		window.location = page;
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function transCom() {
  try {

		var tree = document.getElementById("articles");

		if (tree.view==null || tree.view.rowCount<=0) {
			showWarning("Le devis ne contient aucune ligne !");
		}
		else {
			if (window.confirm("Etes-vous sr de vouloir passer le devis en commande ?")) {
				var corps = cookie() +"&Page=Facturation/Devis/transDevisComWeb.tmpl&ContentType=xml&Devis_Id="+ devis_id;
				var p = requeteHTTP(corps);

				var com_web_id = p.responseXML.documentElement.getAttribute("Com_Web_Id");

				var page = "chrome://opensi/content/facturation/user/web/menuCommande.xul?"+ cookie() +"&num_com="+ com_web_id;
	  		window.location = page;
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function transFacture() {
  try {

		var tree = document.getElementById("articles");

		if (tree.view==null || tree.view.rowCount<=0) {
			showWarning("Le devis ne contient aucune ligne !");
		}
		else {
			if (window.confirm("Etes-vous sr de vouloir passer le devis en facture ?")) {
				var corps = cookie() + "&Page=Facturation/Devis/transDevisFacture.tmpl&ContentType=xml&Devis_Id="+ devis_id;
				var p = requeteHTTP(corps);

				var facture_id = p.responseXML.documentElement.getAttribute("Facture_Id");

				var page = "chrome://opensi/content/facturation/user/factu_directe/edition_facture.xul?"+ cookie() +"&Facture_Id="+ facture_id;
    		window.location = page;
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function enregistrerDevis() {
  try {

		var save = false;

		var client_id = document.getElementById("Client_Id").value;
		var remise = document.getElementById('Remise').value;
		var taux_remise = 0;
		var montant_remise = 0;
		var frais_port = document.getElementById('Frais_Port').value;
		var escompte = document.getElementById('Escompte').value;
		var acompte = document.getElementById('Acompte').value;
		var date_exp = document.getElementById('Date_Exp').value;
		var denomination_fact = document.getElementById('Denomination_Fact').value;
		var adresse_1_fact = document.getElementById('Adresse_1_Fact').value;
		var adresse_2_fact = document.getElementById('Adresse_2_Fact').value;
		var adresse_3_fact = document.getElementById('Adresse_3_Fact').value;
		var code_postal_fact = document.getElementById('Code_Postal_Fact').value;
		var ville_fact = document.getElementById('Ville_Fact').value;
		var code_pays_fact = document.getElementById('Code_Pays_Fact').value;
		var util_R = document.getElementById('Login_Resp').value;
		
		var civ_inter_fact = document.getElementById("Civ_Inter_Fact").value;
		var nom_inter_fact = document.getElementById("Nom_Inter_Fact").value;
		var prenom_inter_fact = document.getElementById("Prenom_Inter_Fact").value;
		var tel_inter_fact = document.getElementById("Tel_Inter_Fact").value;
		var fax_inter_fact = document.getElementById('Fax_Inter_Fact').value;
		var email_inter_fact = document.getElementById('Email_Inter_Fact').value;
		
		var denomination_liv = document.getElementById('Denomination_Liv').value;
		var adresse_1_liv = document.getElementById('Adresse_1_Liv').value;
		var adresse_2_liv = document.getElementById('Adresse_2_Liv').value;
		var adresse_3_liv = document.getElementById('Adresse_3_Liv').value;
		var code_postal_liv = document.getElementById('Code_Postal_Liv').value;
		var ville_liv = document.getElementById('Ville_Liv').value;
		var code_pays_liv = document.getElementById('Code_Pays_Liv').value;
		
		var civ_inter_liv = document.getElementById("Civ_Inter_Liv").value;
		var nom_inter_liv = document.getElementById("Nom_Inter_Liv").value;
		var prenom_inter_liv = document.getElementById("Prenom_Inter_Liv").value;
		var tel_inter_liv = document.getElementById("Tel_Inter_Liv").value;
		var fax_inter_liv = document.getElementById('Fax_Inter_Liv').value;
		var email_inter_liv = document.getElementById('Email_Inter_Liv').value;
		
		var num_tva = assujettiTVA?document.getElementById('Num_TVA').value:"";
		

		if (isEmpty(remise) || (type_remise=='P'?!isTaux(remise):!isPositiveOrNull(remise))) { showWarning("Remise incorrecte !"); }
		else if (isEmpty(denomination_fact)) { showWarning("Veuillez indiquer la raison sociale du client de facturation !"); }
		else if (isEmpty(adresse_1_fact)) { showWarning("Veuillez indiquer l'adresse du client de facturation !"); }
		else if (isEmpty(ville_fact)) { showWarning("Veuillez indiquer la ville du client de facturation !"); }
		else if (isEmpty(denomination_liv)) { showWarning("Veuillez indiquer la raison sociale du client de livraison !"); }
		else if (isEmpty(adresse_1_liv)) { showWarning("Veuillez indiquer l'adresse du client de livraison !"); }
		else if (isEmpty(ville_liv)) { showWarning("Veuillez indiquer la ville du client de livraison !"); }
		else if (isEmpty(frais_port) || !isPositiveOrNull(frais_port)) { showWarning("Frais de port incorrects !"); }
		else if (isEmpty(escompte) || !isTaux(escompte)) { showWarning("Taux d'escompte incorrect !"); }
		else if (isEmpty(acompte) || !isPositiveOrNull(acompte)) { showWarning("Montant d'acompte incorrect !"); }
		else if (!isEmpty(date_exp) && !isDate(date_exp)) { showWarning("Date d'expiration de l'offre incorrecte !"); }
		else if (!isEmpty(tel_inter_fact) && !isPhone(tel_inter_fact)) { showWarning("Numro de tlphone de facturation incorrect !"); }
		else if (!isEmpty(fax_inter_fact) && !isPhone(fax_inter_fact)) { showWarning("Numro de fax de facturation incorrect !"); }
		else if (!isEmpty(email_inter_fact) && !isEmail(email_inter_fact)) { showWarning("Adresse e-mail de facturation incorrecte !"); }
		else if (!isEmpty(tel_inter_liv) && !isPhone(tel_inter_liv)) { showWarning("Numro de tlphone de livraison incorrect !"); }
		else if (!isEmpty(fax_inter_liv) && !isPhone(fax_inter_liv)) { showWarning("Numro de fax de livraison incorrect !"); }
		else if (!isEmpty(email_inter_liv) && !isEmail(email_inter_liv)) { showWarning("Adresse e-mail de livraison incorrecte !"); }
		else {

			var corps;

			if (assujettiTVA && code_pays_liv!="FR" && isEmpty(num_tva) && zoneUE) {
				showWarning("Attention : vous n'avez pas saisi le numro de tva intra-communautaire !");
			}

			if (mode=="C") {
				corps = cookie() +"&Page=Facturation/Devis/creerDevis.tmpl&ContentType=xml";
			}
			else {
				corps = cookie() +"&Page=Facturation/Devis/modifierDevis.tmpl&ContentType=xml&Devis_Id="+ devis_id;
			}

			
			if (type_remise=='P') {
				taux_remise = remise;
			}
			else {
				var montant_base = (editionTTC?document.getElementById('pttcMontantTTC').value:document.getElementById('MontantHT').value);
				taux_remise = (montant_base>0?remise/montant_base*100:0);
				montant_remise = remise;
			}
			
			corps += "&Taux_Remise="+ taux_remise +"&Frais_Port="+ frais_port +"&Escompte="+ escompte +"&Acompte="+ acompte +"&Montant_Remise="+ montant_remise;
			corps += "&Commentaires="+ urlEncode(document.getElementById('Commentaires').value);
			corps += "&Imp_Com="+ (document.getElementById('Imp_Com').checked?"1":"0");
			corps += "&Date_Exp="+ (!isEmpty(date_exp)?prepareDateJava(date_exp):"");
			corps += "&Total_HT="+ currentTotalHT;
			corps += "&Montant_TTC="+ currentMontantTTC;
			corps += "&Code_Tarif="+ document.getElementById('Code_Tarif').value;
			corps += "&Regime_TVA="+ document.getElementById('Regime_TVA').value;

			corps += "&Raison_Sociale="+ urlEncode(denomination_fact);
			corps += "&Adresse="+ urlEncode(adresse_1_fact);
			corps += "&Comp_Adresse="+ urlEncode(adresse_2_fact);
			corps += "&Adresse_3="+ urlEncode(adresse_3_fact);
			corps += "&Code_Postal="+ urlEncode(code_postal_fact);
			corps += "&Ville="+ urlEncode(ville_fact);
			corps += "&Code_Pays="+ urlEncode(code_pays_fact);
			corps += "&Util_R="+ urlEncode(util_R);
			corps += "&Client_Id="+ urlEncode(client_id);
			corps += "&Civ_Inter="+ urlEncode(civ_inter_fact);
			corps += "&Nom_Inter="+ urlEncode(nom_inter_fact);
			corps += "&Prenom_Inter="+ urlEncode(prenom_inter_fact);
			corps += "&Tel_Inter="+ urlEncode(tel_inter_fact);
			corps += "&Fax_Inter="+ urlEncode(fax_inter_fact);
			corps += "&Email_Inter="+ urlEncode(email_inter_fact);
			
			corps += "&Denomination_Liv="+ urlEncode(denomination_liv);
			corps += "&Adresse_1_Liv="+ urlEncode(adresse_1_liv);
			corps += "&Adresse_2_Liv="+ urlEncode(adresse_2_liv);
			corps += "&Adresse_3_Liv="+ urlEncode(adresse_3_liv);
			corps += "&Code_Postal_Liv="+ urlEncode(code_postal_liv);
			corps += "&Ville_Liv="+ urlEncode(ville_liv);
			corps += "&Code_Pays_Liv="+ urlEncode(code_pays_liv);
			corps += "&Civ_Inter_Liv="+ urlEncode(civ_inter_liv);
			corps += "&Nom_Inter_Liv="+ urlEncode(nom_inter_liv);
			corps += "&Prenom_Inter_Liv="+ urlEncode(prenom_inter_liv);
			corps += "&Tel_Inter_Liv="+ urlEncode(tel_inter_liv);
			corps += "&Fax_Inter_Liv="+ urlEncode(fax_inter_liv);
			corps += "&Email_Inter_Liv="+ urlEncode(email_inter_liv);
			
			corps += "&Taux_TVA_Port="+ tva_port;
			
			corps += "&Edition_TTC="+ (document.getElementById('Edition_TTC').checked?"1":"0");
			corps += "&Assujetti_TVA="+ (assujettiTVA?"1":"0");
			corps += "&Num_TVA_Intra="+ urlEncode(num_tva);
			var p = requeteHTTP(corps);

			if (mode=="C") {
				var contenu = p.responseXML.documentElement;
				devis_id = contenu.getAttribute("Devis_Id");
				charger=false;
				chargerDevis();
			}

			if (mode=="M") {
				corps = cookie() +"&Page=Facturation/Devis/saveArticleDevisTemp.tmpl&ContentType=xml&Devis_Id="+ devis_id;
				p = requeteHTTP(corps);
			}

			setModifie(false);
			save = true;
		}

		return save;

	} catch (e) {
  	recup_erreur(e);
	}
}

/**
 * Enregistrer un devis avec vrifications complmentaires de donnes.
 * Permet d'avoir des tests supplmentaires qui ne sont pas lancs lors de validerLigne()
 * qui appelle enregistrerDevis()
 */
function enregistrerDevisFini() {
    try {
        var date_exp = document.getElementById('Date_Exp').value;
        if (isEmpty(date_exp ) || (!isEmpty(date_exp) && !isDate(date_exp)))
            showWarning("Date d'expiration de l'offre incorrecte !");
        else
            enregistrerDevis();
    } catch (e) {
         recup_erreur(e);   
    }
    
}

function calculTotaux() {
  try {
  	var client_id = document.getElementById("Client_Id").value;
		var client_connu = (client_id!="");

		var tree = document.getElementById("articles");
		document.getElementById('Edition_TTC').disabled = (tree.view==null || tree.view.rowCount>0);
    document.getElementById('Code_Pays_Liv').disabled = (tree.view==null || tree.view.rowCount>0);
   	document.getElementById('chercher_adrliv').disabled = (!client_connu || tree.view==null || tree.view.rowCount>0);
    document.getElementById('bCopierFactVersLiv').disabled = (tree.view==null || tree.view.rowCount>0);
		document.getElementById('Regime_TVA').disabled = (tree.view==null || tree.view.rowCount>0);
		document.getElementById('Assujetti_TVA').disabled = (tree.view==null || tree.view.rowCount>0);
		
		var remise = parseFloat(document.getElementById('Remise').value);
		var taux_escompte = parseFloat(document.getElementById('Escompte').value);
		var frais_port = parseFloat(document.getElementById('Frais_Port').value);
		var acompte = parseFloat(document.getElementById('Acompte').value);

		if ((type_remise=='P'?isTaux(remise):isPositiveOrNull(remise)) && isTaux(taux_escompte) && isPositiveOrNull(frais_port)) {

			var montant_tva = 0;
			var montant_ht = 0;
			var montant_ttc = 0;

			if (tree.view!=null) {

				if (editionTTC) {
					for (var i=0;i<tree.view.rowCount;i++) {

						if (getCellText(tree,i,'ColType_Ligne')!="C") {
							var tva  = getTva(getCellText(tree,i,'ColCode_TVA'));
							montant_ttc += parseFloat(getCellText(tree,i,'ColTotal'));
          		montant_tva += parseFloat(getCellText(tree,i,'ColTotal')) * (tva/100) / (tva/100+1);
						}
					}
					
					var taux_remise = (type_remise=='P'?remise:(montant_ttc==0?0:remise/montant_ttc*100));

					var montant_remise = montant_ttc * parseFloat(taux_remise/100);				

					montant_tva = montant_tva * (1 - parseFloat(taux_remise/100)) + frais_port * (tva_port/100) / (tva_port/100+1);

					var total_ht = montant_ttc - montant_tva - montant_remise + frais_port;			

					var total_ttc = montant_ttc - montant_remise + frais_port;

					currentMontantTTC = total_ttc;
					currentTotalHT = total_ht;

					var montant_escompte = nf.format(total_ttc * parseFloat(taux_escompte/100));

					var net_ttc = total_ttc - montant_escompte - acompte;

					document.getElementById('pttcMontantRemise').value = nf.format(montant_remise);
					document.getElementById('pttcMontantFrais_Port').value = nf.format(frais_port);
					document.getElementById('pttcTVA').value = nf.format(montant_tva);
					document.getElementById('pttcMontantTTC').value = nf.format(montant_ttc);
					document.getElementById('pttcMontantAcompte').value = nf.format(acompte);
					document.getElementById('pttcMontantEscompte').value = nf.format(montant_escompte);
					document.getElementById('pttcTotalTTC').value = nf.format(total_ttc);
					document.getElementById('pttcNetTTC').value = nf.format(net_ttc);
				}				
				else {
					for (var i=0;i<tree.view.rowCount;i++) {

						if (getCellText(tree,i,'ColType_Ligne')!="C") {						
							montant_ht += parseFloat(getCellText(tree,i,'ColTotal'));
          		montant_tva += parseFloat(getCellText(tree,i,'ColTotal')) * getTva(getCellText(tree,i,'ColCode_TVA'))/100;
						}
					}
					
					var taux_remise = (type_remise=='P'?remise:(montant_ht==0?0:remise/montant_ht*100));

					var montant_remise = montant_ht * parseFloat(taux_remise/100);

					var total_ht = montant_ht * (1 - parseFloat(taux_remise/100)) + frais_port;

					montant_tva = montant_tva * (1 - parseFloat(taux_remise/100)) + frais_port * (tva_port/100);

					montant_ttc = total_ht + montant_tva;

					currentMontantTTC = montant_ttc;
					currentTotalHT = total_ht;

					var montant_escompte = nf.format(montant_ttc * parseFloat(taux_escompte/100));

					var total_ttc = montant_ttc - montant_escompte - acompte;

					document.getElementById('MontantHT').value = nf.format(montant_ht);
					document.getElementById('MontantRemise').value = nf.format(montant_remise);
					document.getElementById('MontantFrais_Port').value = nf.format(frais_port);
					document.getElementById('TotalHT').value = nf.format(total_ht);
					document.getElementById('TVA').value = nf.format(montant_tva);
					document.getElementById('MontantTTC').value = nf.format(montant_ttc);
					document.getElementById('MontantAcompte').value = nf.format(acompte);
					document.getElementById('MontantEscompte').value = nf.format(montant_escompte);
					document.getElementById('TotalTTC').value = nf.format(total_ttc);					
				}
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function calculerPoids() {
	try {
		
		var qPoids = new QueryHttp("Facturation/Devis/getPoidsTotal.tmpl");
		qPoids.setParam("Devis_Id", devis_id);
		var p = qPoids.execute();
		
		document.getElementById('poidsTotal').value = p.responseXML.documentElement.getAttribute("Poids");
	} catch (e) {
		recup_erreur(e);
	}
}


function afterRefreshArticles() {
	try {

		calculTotaux();
		scrollToRank();
		document.getElementById('Reference').focus();

	} catch (e) {
  	recup_erreur(e);
	}
}


function scrollToRank() {
	try {

		var tree = document.getElementById("articles");

		if (tree.view!=null && tree.view.rowCount>0 && currentRank>0) {

			var tb = document.getElementById("articles").treeBoxObject;
			var i = 0;
			var trouve = false;

			while (!trouve && i<tree.view.rowCount) {
				
				if (parseIntBis(getCellText(tree,i,'ColRank'))>=currentRank) {
					tb.ensureRowIsVisible(i);
					trouve = true;
				}

				i++;
			}
			if (!trouve) tb.ensureRowIsVisible(tree.view.rowCount-1);
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function demandeEnregistrement() {
  try {

		if (document.getElementById("Modifie").value=="y") {
			if (window.confirm("Voulez-vous enregistrer les modifications apportes au devis ?")) {
				enregistrerDevis();
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function setModifie(m) {
  try {

		if (m) {
			document.getElementById('Modifie').value = "y";
			document.getElementById('labelDevis').setAttribute("label","Devis (modifi)");
			document.getElementById('bVisualiser').disabled = true;
			document.getElementById('bCopierDevis').disabled = true;
			document.getElementById('bProforma').disabled = true;
			document.getElementById('bTransAff').disabled = true;
			document.getElementById('bTransCom').disabled = true;
			document.getElementById('bTransFac').disabled = true;
		}
		else {
			document.getElementById('Modifie').value = "n";
			document.getElementById('labelDevis').setAttribute("label","Devis");
			document.getElementById('bVisualiser').disabled = false;
			document.getElementById('bCopierDevis').disabled = false;
			document.getElementById('bProforma').disabled = (etat_devis!='N');
			document.getElementById('bTransAff').disabled = (etat_devis!='N');
			document.getElementById('bTransCom').disabled = (etat_devis!='N');
			document.getElementById('bTransFac').disabled = (etat_devis!='N');
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function init_tree() {
  try {

    var paramlist = "&Page=Facturation/GetRDF/articles_devis.tmpl&ContentType=xml&Devis_Id="+ devis_id;
    load_rdf_async('articles', getUrlOpeneas(paramlist),chargerDevis);

  } catch (e) {
    recup_erreur(e);
  }
}

function delete_tree() {
  try {

    var database = document.getElementById("articles").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('articles').builder.rebuild();

  } catch (e) {
    recup_erreur(e);
  }
}


function nouveauDevis() {
  try {

		var qVenteTTC = new QueryHttp("Config/gestion_commerciale/preferences/getParam.tmpl"); 
		var result = qVenteTTC.execute();

		var venteTTC = (result.responseXML.documentElement.getAttribute('Vente_TTC')==1);

		document.getElementById('Edition_TTC').checked = venteTTC;		
		changerTypeEdition(venteTTC);
		
		assujettiTVA = false;		
		document.getElementById('Assujetti_TVA').checked = false;
		document.getElementById('Num_TVA').disabled = true;
		document.getElementById('Num_TVA').value = "";

		mode = "C";

		document.getElementById('Denomination_Fact').disabled = false;
		document.getElementById('Adresse_1_Fact').disabled = false;
		document.getElementById('Adresse_2_Fact').disabled = false;
		document.getElementById('Adresse_3_Fact').disabled = false;
		document.getElementById('Code_Postal_Fact').disabled = false;
		document.getElementById('Ville_Fact').disabled = false;
		document.getElementById('Code_Pays_Fact').disabled = false;
		document.getElementById('Code_Tarif').disabled = false;
		document.getElementById('Regime_TVA').disabled = false;
		document.getElementById('Login_Resp').disabled = false;

		document.getElementById('Civ_Inter_Fact').disabled = false;
		document.getElementById('Nom_Inter_Fact').disabled = false;
		document.getElementById('Prenom_Inter_Fact').disabled = false;
		document.getElementById('Tel_Inter_Fact').disabled = false;
		document.getElementById('Fax_Inter_Fact').disabled = false;
		document.getElementById('Email_Inter_Fact').disabled = false;
		
		document.getElementById('Denomination_Liv').disabled = false;
		document.getElementById('Adresse_1_Liv').disabled = false;
		document.getElementById('Adresse_2_Liv').disabled = false;
		document.getElementById('Adresse_3_Liv').disabled = false;
		document.getElementById('Code_Postal_Liv').disabled = false;
		document.getElementById('Ville_Liv').disabled = false;
		document.getElementById('Code_Pays_Liv').disabled = false;

		document.getElementById('Civ_Inter_Liv').disabled = false;
		document.getElementById('Nom_Inter_Liv').disabled = false;
		document.getElementById('Prenom_Inter_Liv').disabled = false;
		document.getElementById('Tel_Inter_Liv').disabled = false;
		document.getElementById('Fax_Inter_Liv').disabled = false;
		document.getElementById('Email_Inter_Liv').disabled = false;

		document.getElementById('Commentaires').value = "";
		document.getElementById('Date_Devis').value = "";
		document.getElementById('Numero').value = "";
		document.getElementById('Imp_Com').checked = false;
		document.getElementById('Remise').value = "0.00";
		document.getElementById('Escompte').value = "0.00";
		document.getElementById('Acompte').value = "0.00";
		document.getElementById('Frais_Port').value = "0.00";
		document.getElementById('Date_Exp').value = "";

		document.getElementById('Denomination_Fact').value = "";
		document.getElementById('Adresse_1_Fact').value = "";
		document.getElementById('Adresse_2_Fact').value = "";
		document.getElementById('Adresse_3_Fact').value = "";
		document.getElementById('Code_Postal_Fact').value = "";
		document.getElementById('Ville_Fact').value = "";
		document.getElementById('Code_Pays_Fact').value = "FR";
		
		document.getElementById('Denomination_Liv').value = "";
		document.getElementById('Adresse_1_Liv').value = "";
		document.getElementById('Adresse_2_Liv').value = "";
		document.getElementById('Adresse_3_Liv').value = "";
		document.getElementById('Code_Postal_Liv').value = "";
		document.getElementById('Ville_Liv').value = "";
		document.getElementById('Code_Pays_Liv').value = "FR";
		selectPaysLiv();

		document.getElementById('MontantHT').value = "0.00";
		document.getElementById('MontantRemise').value = "0.00";
		document.getElementById('MontantFrais_Port').value = "0.00";
		document.getElementById('TotalHT').value = "0.00";
		document.getElementById('TVA').value = "0.00";
		document.getElementById('MontantTTC').value = "0.00";
		document.getElementById('MontantEscompte').value = "0.00";
		document.getElementById('MontantAcompte').value = "0.00";
		document.getElementById('TotalTTC').value = "0.00";
		
		document.getElementById('pttcMontantRemise').value = "0.00";
		document.getElementById('pttcMontantFrais_Port').value = "0.00";
		document.getElementById('pttcTVA').value = "0.00";
		document.getElementById('pttcMontantTTC').value = "0.00";
		document.getElementById('pttcMontantEscompte').value = "0.00";
		document.getElementById('pttcMontantAcompte').value = "0.00";
		document.getElementById('pttcTotalTTC').value = "0.00";
		document.getElementById('pttcNetTTC').value = "0.00";

		document.getElementById('Code_Tarif').value = 1;
		document.getElementById('Regime_TVA').value = "G";

		document.getElementById('Creation').label = "";
		document.getElementById('Modification').label = "";
		document.getElementById('Creation').collapsed = true;
		document.getElementById('Modification').collapsed = true;
		document.getElementById('Fiche').label = "";

		document.getElementById('Login_Resp').value = get_cookie('User');
		document.getElementById('labelClientFact').setAttribute("value", "Client");
		document.getElementById('labelClientLiv').setAttribute("value", "Client");
		
		document.getElementById('Client_Id').value = "";

		ajouterLigne("I");

		delete_tree();

		setModifie(false);
		document.getElementById('bVisualiser').disabled = true;
		document.getElementById('bCopierDevis').disabled = true;
		document.getElementById('bProforma').collapsed = true;
		document.getElementById('bTransAff').collapsed = true;
		document.getElementById('bTransCom').collapsed = true;
		document.getElementById('bTransFac').collapsed = true;
		
		document.getElementById('chercher_adrfact').disabled = true;
		document.getElementById('chercher_inter').disabled = true;
		document.getElementById('chercher_adrliv').disabled = true;
		document.getElementById('chercher_inter_liv').disabled = true;
		document.getElementById('bCopierFactVersLiv').disabled = false;

	} catch (e) {
  	recup_erreur(e);
  }
}


function chargerDevis() {
  try {

		mode = "M";
		
		document.getElementById('Code_Tarif').disabled = true;
		document.getElementById('bTransFac').collapsed = false;
		document.getElementById('bTransCom').collapsed = false;
		document.getElementById('bProforma').collapsed = false;

		var corps = cookie() +"&Page=Facturation/Devis/getDevis.tmpl&ContentType=xml&Devis_Id="+ devis_id;

		var p = requeteHTTP(corps);

		var contenu = p.responseXML.documentElement;

		var numero = contenu.getAttribute('Num_Entier');

		document.getElementById('Remise').value = contenu.getAttribute('Remise');
		type_remise = contenu.getAttribute('Type_Remise');
		document.getElementById('bRemise').setAttribute("label", (type_remise=='P'?"%":"\u20AC"));
		document.getElementById('Escompte').value = contenu.getAttribute('Escompte');
		document.getElementById('Acompte').value = contenu.getAttribute('Acompte');
		document.getElementById('Frais_Port').value = contenu.getAttribute('Frais_Port');
		document.getElementById('Commentaires').value = contenu.getAttribute('Commentaires');
		document.getElementById('Imp_Com').checked = contenu.getAttribute('Imp_Com')=="1";
		document.getElementById('Date_Devis').value = contenu.getAttribute('Date_Devis');
		document.getElementById('Numero').value = numero;
		document.getElementById('Date_Exp').value = contenu.getAttribute('Date_Exp');

		document.getElementById('Denomination_Fact').value = contenu.getAttribute('Raison_Sociale');
		document.getElementById('Adresse_1_Fact').value = contenu.getAttribute('Adresse');
		document.getElementById('Adresse_2_Fact').value = contenu.getAttribute('Comp_Adresse');
		document.getElementById('Adresse_3_Fact').value = contenu.getAttribute('Adresse_3');
		document.getElementById('Code_Postal_Fact').value = contenu.getAttribute('Code_Postal');
		document.getElementById('Ville_Fact').value = contenu.getAttribute('Ville');
		document.getElementById('Code_Pays_Fact').value = contenu.getAttribute('Code_Pays');
		
		document.getElementById('Denomination_Liv').value = contenu.getAttribute('Denomination_Liv');
		document.getElementById('Adresse_1_Liv').value = contenu.getAttribute('Adresse_1_Liv');
		document.getElementById('Adresse_2_Liv').value = contenu.getAttribute('Adresse_2_Liv');
		document.getElementById('Adresse_3_Liv').value = contenu.getAttribute('Adresse_3_Liv');
		document.getElementById('Code_Postal_Liv').value = contenu.getAttribute('Code_Postal_Liv');
		document.getElementById('Ville_Liv').value = contenu.getAttribute('Ville_Liv');
		document.getElementById('Code_Pays_Liv').value = contenu.getAttribute('Code_Pays_Liv');

		document.getElementById('Civ_Inter_Fact').value = contenu.getAttribute('Civ_Inter');
		document.getElementById('Nom_Inter_Fact').value = contenu.getAttribute('Nom_Inter');
		document.getElementById('Prenom_Inter_Fact').value = contenu.getAttribute('Prenom_Inter');
		document.getElementById('Tel_Inter_Fact').value = contenu.getAttribute('Tel_Inter');
		document.getElementById('Fax_Inter_Fact').value = contenu.getAttribute('Fax_Inter');
		document.getElementById('Email_Inter_Fact').value = contenu.getAttribute('Email_Inter');
		
		document.getElementById('Civ_Inter_Liv').value = contenu.getAttribute('Civ_Inter_Liv');
		document.getElementById('Nom_Inter_Liv').value = contenu.getAttribute('Nom_Inter_Liv');
		document.getElementById('Prenom_Inter_Liv').value = contenu.getAttribute('Prenom_Inter_Liv');
		document.getElementById('Tel_Inter_Liv').value = contenu.getAttribute('Tel_Inter_Liv');
		document.getElementById('Fax_Inter_Liv').value = contenu.getAttribute('Fax_Inter_Liv');
		document.getElementById('Email_Inter_Liv').value = contenu.getAttribute('Email_Inter_Liv');

		document.getElementById('Code_Tarif').value = contenu.getAttribute('Code_Tarif');
		document.getElementById('Regime_TVA').value = contenu.getAttribute('Regime_TVA');
		assujettiTVA = (contenu.getAttribute('Assujetti_TVA')=="1");		
		selectPaysLiv();
		
		var typeEdition = (contenu.getAttribute('Edition_TTC')=="1");
		
		document.getElementById('Edition_TTC').checked = typeEdition;
		
		document.getElementById('Assujetti_TVA').checked = assujettiTVA;
		document.getElementById('Num_TVA').disabled = !assujettiTVA;
		document.getElementById('Num_TVA').value = contenu.getAttribute("Num_TVA_Intra");

		var client_id = contenu.getAttribute('Client_Id');
    document.getElementById('Client_Id').value = client_id;
		var client_connu = (client_id!="");
		
		if (client_connu) {
			document.getElementById('labelClientFact').setAttribute("value", "Client N "+ client_id);
			document.getElementById('labelClientLiv').setAttribute("value", "Client N "+ client_id);
		}
		else {
			document.getElementById('labelClientFact').setAttribute("value", "Client");
			document.getElementById('labelClientLiv').setAttribute("value", "Client");
		}
		
		document.getElementById('Login_Resp').value = contenu.getAttribute('Util_R');
		
		document.getElementById('bTransAff').collapsed = !client_connu;
		document.getElementById('chercher_adrfact').disabled = !client_connu;
		document.getElementById('chercher_inter').disabled = !client_connu;
		document.getElementById('chercher_adrliv').disabled = !client_connu;
		document.getElementById('chercher_inter_liv').disabled = !client_connu;

		document.getElementById('Creation').label = "Devis cr le "+ contenu.getAttribute('Date_Creation') +" par "+ contenu.getAttribute('Login_Createur');
		document.getElementById('Modification').label = "Dernire modification le "+ contenu.getAttribute('Date_Maj') +" par "+ contenu.getAttribute('Login_Maj');
		document.getElementById('Fiche').label = "Devis N "+ numero;
		document.getElementById('Creation').collapsed = false;
		document.getElementById('Modification').collapsed = false;

		etat_devis = contenu.getAttribute("Etat");
		
		setModifie(false);

		if (etat_devis=='A' || etat_devis=='F' || etat_devis=='C') {
			disableAll();
		}
		else if (initLigne) {
			ajouterLigne("I");
			initLigne = false;
		}

		changerTypeEdition(typeEdition);

	} catch (e) {
    recup_erreur(e);
  }
}


function init_tree_temp() {
  try {

    var paramlist = "&Page=Facturation/GetRDF/articles_devis.tmpl&ContentType=xml&Temp=true&Devis_Id="+ devis_id;
    load_rdf_async('articles', getUrlOpeneas(paramlist), afterRefreshArticles);

  } catch (e) {
    recup_erreur(e);
  }
}


function visualiserDevis() {
  try {

		var tree = document.getElementById("articles");

		if (tree.view==null || tree.view.rowCount<=0) {
			showWarning("Le devis ne contient aucune ligne !");
		}
		else {
			var client_id = document.getElementById("Client_Id").value;
	  	window.location = "chrome://opensi/content/facturation/user/devis/devis.xul?"+ cookie() +"&Devis_Id="+ devis_id +"&Client_Id="+ client_id;
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function editerProforma() {
  try {

		var tree = document.getElementById("articles");

		if (tree.view==null || tree.view.rowCount<=0) {
			showWarning("Le devis ne contient aucune ligne !");
		}
		else {
			var client_id = document.getElementById("Client_Id").value;
			var page = "chrome://opensi/content/facturation/user/devis/devis.xul?"+ cookie();
      page += "&Devis_Id="+ devis_id;
      page += "&Client_Id=" + client_id;
      page += "&Proforma=true";
	  	window.location = page;
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function copierDevis() {
	try {
		var qCopie = new QueryHttp("Facturation/Devis/copierDevis.tmpl");
		qCopie.setParam("Devis_Id", devis_id);
		var result = qCopie.execute();
		var new_devis_id = result.responseXML.documentElement.getAttribute('Devis_Id');
		
		var page = "chrome://opensi/content/facturation/user/devis/edition_devis.xul?"+ cookie();
    page += "&Devis_Id="+ new_devis_id;
	  window.location = page;
	} catch (e) {
		recup_erreur(e);
	}
}


function editerCommentaire() {
  try {

		var tree = document.getElementById("articles");

		if (tree.view!=null && tree.currentIndex!=-1) {

			var rank = getCellText(tree,tree.currentIndex,'ColRank');

			var url = "chrome://opensi/content/facturation/user/devis/commentaire.xul?"+ cookie() +"&Devis_Id="+ devis_id +"&Rank="+ rank;
    	window.openDialog(url,'','chrome,modal,centerscreen');

			delete_tree();
			init_tree_temp();
			ajouterLigne("I");
			setModifie(true);
		}
		else {
			showWarning("Aucun article ou commentaire slectionn !");
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function charger_coord() {
  try {
		var client_id = document.getElementById("Client_Id").value;
		// AEL : CRM
        var partenaire = document.getElementById("Partenaire").value
		var corps = cookie() +"&Page=Facturation/Clients/getCoord.tmpl&ContentType=xml&Client_Id="+ urlEncode(client_id);
        corps += "&Partenaire=" + partenaire;

		var p = requeteHTTP(corps);

		var contenu = p.responseXML.documentElement;
		
		document.getElementById("Login_Resp").value = contenu.getAttribute("Util_R");
		document.getElementById("Remise").value = contenu.getAttribute("Remise");
		document.getElementById("Code_Tarif").value = contenu.getAttribute("Code_Tarif");
		
		assujettiTVA = (contenu.getAttribute("Assujetti_TVA")=="1");
		document.getElementById('Assujetti_TVA').checked=assujettiTVA;
		document.getElementById('Num_TVA').disabled=!assujettiTVA;
		document.getElementById('Num_TVA').value=contenu.getAttribute("Num_TVA_Intra");

		document.getElementById("Denomination_Fact").value = contenu.getAttribute("Denomination_Fact");
		document.getElementById("Adresse_1_Fact").value = contenu.getAttribute("Adresse_1_Fact");		
		document.getElementById("Adresse_2_Fact").value = contenu.getAttribute("Adresse_2_Fact");
		document.getElementById("Adresse_3_Fact").value = contenu.getAttribute("Adresse_3_Fact");
		document.getElementById("Code_Postal_Fact").value = contenu.getAttribute("Code_Postal_Fact");
		document.getElementById("Ville_Fact").value = contenu.getAttribute("Ville_Fact");
    document.getElementById("Code_Pays_Fact").value = contenu.getAttribute("Code_Pays_Fact");
		
		document.getElementById("Civ_Inter_Fact").value = contenu.getAttribute("Civ_Inter_Fact");
		document.getElementById("Nom_Inter_Fact").value = contenu.getAttribute("Nom_Inter_Fact");
		document.getElementById("Prenom_Inter_Fact").value = contenu.getAttribute("Prenom_Inter_Fact");
		document.getElementById("Tel_Inter_Fact").value = contenu.getAttribute("Tel_Inter_Fact");
		document.getElementById("Fax_Inter_Fact").value = contenu.getAttribute("Fax_Inter_Fact");
		document.getElementById("Email_Inter_Fact").value = contenu.getAttribute("Email_Inter_Fact");
		
		document.getElementById("Denomination_Liv").value = contenu.getAttribute("Denomination_Liv");
		document.getElementById("Adresse_1_Liv").value = contenu.getAttribute("Adresse_1_Liv");
		document.getElementById("Adresse_2_Liv").value = contenu.getAttribute("Adresse_2_Liv");
		document.getElementById("Adresse_3_Liv").value = contenu.getAttribute("Adresse_3_Liv");
		document.getElementById("Code_Postal_Liv").value = contenu.getAttribute("Code_Postal_Liv");		
		document.getElementById("Ville_Liv").value = contenu.getAttribute("Ville_Liv");
    document.getElementById("Code_Pays_Liv").value = contenu.getAttribute("Code_Pays_Liv");
    selectPaysLiv();
    
    document.getElementById("Civ_Inter_Liv").value = contenu.getAttribute("Civ_Inter_Liv");
		document.getElementById("Nom_Inter_Liv").value = contenu.getAttribute("Nom_Inter_Liv");
		document.getElementById("Prenom_Inter_Liv").value = contenu.getAttribute("Prenom_Inter_Liv");
		document.getElementById("Tel_Inter_Liv").value = contenu.getAttribute("Tel_Inter_Liv");
		document.getElementById("Fax_Inter_Liv").value = contenu.getAttribute("Fax_Inter_Liv");
		document.getElementById("Email_Inter_Liv").value = contenu.getAttribute("Email_Inter_Liv");
		
		document.getElementById('labelClientFact').setAttribute("value", "Client N "+ client_id);
		document.getElementById('labelClientLiv').setAttribute("value", "Client N "+ client_id);

		document.getElementById('bTransAff').collapsed = false;
		document.getElementById('bTransCom').disabled = false;
		document.getElementById('chercher_adrfact').disabled = false;
		document.getElementById('chercher_inter').disabled = false;
		document.getElementById('chercher_inter_liv').disabled = false;
		
		var client_connu = (client_id!="");
		var tree = document.getElementById("articles");
   	document.getElementById('chercher_adrliv').disabled = (!client_connu || tree.view==null || tree.view.rowCount>0);
    document.getElementById('bCopierFactVersLiv').disabled = (tree.view==null || tree.view.rowCount>0);
		document.getElementById('chercher_adrfact').disabled = !client_connu;
		document.getElementById('chercher_inter').disabled = !client_connu;
		document.getElementById('chercher_inter_liv').disabled = !client_connu;
		
		ajouterLigne("I");

	} catch (e) {
  	recup_erreur(e);
  }
}

function rechercherClient() {
  try {

		var url = "chrome://opensi/content/facturation/user/clients/rech_client.xul?"+ cookie() +"&Nouv=true&Client_Express=true&Modif_Action=false&Field_Client=Client_Id&Bloque=true";
    window.openDialog(url,'','chrome,modal,centerscreen');
    var client_id = document.getElementById("Client_Id").value;

		if (client_id != "") {
			setModifie(true);
			charger_coord();
		}

	} catch (e) {
  	recup_erreur(e);
  }
}


function evaluer(elem, ev) {
	try {

		if (ev.keyCode==13) {
			var nf4 = new NumberFormat("0.00##", false);
			elem.value = nf4.format(calcExpr(elem.value));
		}

	}	catch(e) {
		recup_erreur(e);
	}
}


function changerTypeEdition(chgType) {
	try {

		editionTTC = chgType;
		
		if (editionTTC) {
			document.getElementById('ColTotal').setAttribute("label", "Total TTC");
			document.getElementById('ColPU').setAttribute("label", "P.U TTC");
			document.getElementById('lblFrais_Port').value = "Frais de port (ttc) :";
			document.getElementById('lblPU').value = "P.U TTC :";
			document.getElementById('piedTTC').collapsed = false;
			document.getElementById('piedHT').collapsed = true;
		}
		else {
			document.getElementById('ColTotal').setAttribute("label", "Total HT");
			document.getElementById('ColPU').setAttribute("label", "P.U HT");
			document.getElementById('lblFrais_Port').value = "Frais de port (ht) :";
			document.getElementById('lblPU').value = "P.U HT :";
			document.getElementById('piedTTC').collapsed = true;
			document.getElementById('piedHT').collapsed = false;			
		}
		
		calculTotaux();

	}	catch(e) {
		recup_erreur(e);
	}
}


function changerAssujettiTVA(etat) {
	try {

		assujettiTVA = etat;
		document.getElementById('Num_TVA').disabled=!assujettiTVA;
		listeTVA();
		setModifie(true);

	}	catch(e) {
		recup_erreur(e);
	}
}


function changerTypeVente() {
	try {
	  var qTypeVente = new QueryHttp("GetPays.tmpl");
	  qTypeVente.setParam("Code_Pays", document.getElementById("Code_Pays_Liv").value);
	  var result = qTypeVente.execute();
	  zoneUE = (result.responseXML.documentElement.getAttribute("zone_ue")=="1");
	}	catch(e) {
		recup_erreur(e);
	}
}


function rechercherAdrFact() {
  try {

		var url = "chrome://opensi/content/facturation/user/commun/popup-choixAdresse.xul?"+ cookie() +"&Client_Id="+ urlEncode(document.getElementById('Client_Id').value);
    window.openDialog(url,'','chrome,modal,centerscreen', reporterAdrFact);

	} catch (e) {
  	recup_erreur(e);
  }
}


function reporterAdrFact(nom, adr1, adr2, adr3, cp, ville, pays, code_pays, contact_fact, contact_liv) {
  try {

		document.getElementById("Denomination_Fact").value = nom;
		document.getElementById("Adresse_1_Fact").value = adr1;		
		document.getElementById("Adresse_2_Fact").value = adr2;
		document.getElementById("Adresse_3_Fact").value = adr3;
		document.getElementById("Code_Postal_Fact").value = cp;
		document.getElementById("Ville_Fact").value = ville;
	  document.getElementById("Code_Pays_Fact").value = code_pays;
	  
	  if (!isEmpty(contact_fact)) {
	  	var qInterFact = new QueryHttp("Facturation/Clients/getContact.tmpl");
	  	qInterFact.setParam("Num_Inter", contact_fact);
	  	var result = qInterFact.execute();
	  	var content = result.responseXML.documentElement;
	  	reporterInterFact(content.getAttribute("Civilite"),content.getAttribute("Civ_Courte"),content.getAttribute("Nom"),content.getAttribute("Prenom"),content.getAttribute("Tel"),content.getAttribute("Fax"),content.getAttribute("Email"));
	  }
		setModifie(true);

	} catch (e) {
  	recup_erreur(e);
  }
}


function rechercherInterlocuteurFact() {
  try {

		var url = "chrome://opensi/content/facturation/user/commun/popup-choixInter.xul?"+ cookie() +"&Client_Id="+ urlEncode(document.getElementById('Client_Id').value);
    window.openDialog(url,'','chrome,modal,centerscreen', reporterInterFact);

	} catch (e) {
  	recup_erreur(e);
  }
}


function reporterInterFact(civ, civ_courte, nom, prenom, tel, fax, email) {
  try {
		document.getElementById("Civ_Inter_Fact").value = civ;
		document.getElementById("Nom_Inter_Fact").value = nom;		
		document.getElementById("Prenom_Inter_Fact").value = prenom;
		document.getElementById("Tel_Inter_Fact").value = tel;
		document.getElementById("Fax_Inter_Fact").value = fax;
		document.getElementById("Email_Inter_Fact").value = email;
		
		setModifie(true);

	} catch (e) {
  	recup_erreur(e);
  }
}


function copierFactVersLiv() {
	try {
		document.getElementById('Denomination_Liv').value = document.getElementById('Denomination_Fact').value;
		document.getElementById("Adresse_1_Liv").value = document.getElementById("Adresse_1_Fact").value;		
		document.getElementById("Adresse_2_Liv").value = document.getElementById("Adresse_2_Fact").value;
		document.getElementById("Adresse_3_Liv").value = document.getElementById("Adresse_3_Fact").value;
		document.getElementById("Code_Postal_Liv").value = document.getElementById("Code_Postal_Fact").value;
		document.getElementById("Ville_Liv").value = document.getElementById("Ville_Fact").value;
	  document.getElementById("Code_Pays_Liv").value = document.getElementById("Code_Pays_Fact").value;
	  selectPaysLiv();
	  document.getElementById("Civ_Inter_Liv").value = document.getElementById("Civ_Inter_Fact").value;
		document.getElementById("Nom_Inter_Liv").value = document.getElementById("Nom_Inter_Fact").value;		
		document.getElementById("Prenom_Inter_Liv").value = document.getElementById("Prenom_Inter_Fact").value;
		document.getElementById("Tel_Inter_Liv").value = document.getElementById("Tel_Inter_Fact").value;
		document.getElementById("Fax_Inter_Liv").value = document.getElementById("Fax_Inter_Fact").value;
		document.getElementById("Email_Inter_Liv").value = document.getElementById("Email_Inter_Fact").value;
	} catch (e) {
		recup_erreur(e);
	}
}


function rechercherAdrLiv() {
  try {

		var url = "chrome://opensi/content/facturation/user/commun/popup-choixAdresse.xul?"+ cookie() +"&Client_Id="+ urlEncode(document.getElementById('Client_Id').value);
    window.openDialog(url,'','chrome,modal,centerscreen', reporterAdrLiv);

	} catch (e) {
  	recup_erreur(e);
  }
}


function reporterAdrLiv(nom, adr1, adr2, adr3, cp, ville, pays, code_pays, contact_fact, contact_liv) {
  try {

		document.getElementById("Denomination_Liv").value = nom;
		document.getElementById("Adresse_1_Liv").value = adr1;		
		document.getElementById("Adresse_2_Liv").value = adr2;
		document.getElementById("Adresse_3_Liv").value = adr3;
		document.getElementById("Code_Postal_Liv").value = cp;
		document.getElementById("Ville_Liv").value = ville;
	  document.getElementById("Code_Pays_Liv").value = code_pays;
	  selectPaysLiv();
	  
		if (!isEmpty(contact_liv)) {
	  	var qInterLiv = new QueryHttp("Facturation/Clients/getContact.tmpl");
	  	qInterLiv.setParam("Num_Inter", contact_liv);
	  	var result = qInterLiv.execute();
	  	var content = result.responseXML.documentElement;
	  	reporterInterLiv(content.getAttribute("Civilite"),content.getAttribute("Civ_Courte"),content.getAttribute("Nom"),content.getAttribute("Prenom"),content.getAttribute("Tel"),content.getAttribute("Fax"),content.getAttribute("Email"));
	  }
	  setModifie(true);

	} catch (e) {
  	recup_erreur(e);
  }
}


function rechercherInterlocuteurLiv() {
  try {

		var url = "chrome://opensi/content/facturation/user/commun/popup-choixInter.xul?"+ cookie() +"&Client_Id="+ urlEncode(document.getElementById('Client_Id').value);
    window.openDialog(url,'','chrome,modal,centerscreen', reporterInterLiv);

	} catch (e) {
  	recup_erreur(e);
  }
}


function reporterInterLiv(civ, civ_courte, nom, prenom, tel, fax, email) {
  try {
		document.getElementById("Civ_Inter_Liv").value = civ;
		document.getElementById("Nom_Inter_Liv").value = nom;		
		document.getElementById("Prenom_Inter_Liv").value = prenom;
		document.getElementById("Tel_Inter_Liv").value = tel;
		document.getElementById("Fax_Inter_Liv").value = fax;
		document.getElementById("Email_Inter_Liv").value = email;
		
		setModifie(true);
	} catch (e) {
  	recup_erreur(e);
  }
}


function choisirMentions() {
  try {
  	
  	var ok = true;
  	
  	if (mode=="C") {
			ok = enregistrerDevis();
		}

		if (ok) {
			var url = "chrome://opensi/content/facturation/user/commun/popup-choix_mentions.xul?"+ cookie() +"&Type_Doc=Devis&Doc_Id="+ devis_id;
    	window.openDialog(url,'','chrome,modal,centerscreen',setModifie);
		}

	} catch (e) {
  	recup_erreur(e);
  }
}


function retour_devis() {
  try {

    window.location = "chrome://opensi/content/facturation/user/devis/menu_devis.xul?"+ cookie();

  } catch (e) {
    recup_erreur(e);
  }
}


function retour_menu_principal() {
  try {

    window.location = "chrome://opensi/content/facturation/user/menu_principal.xul?"+ cookie();

  } catch (e) {
    recup_erreur(e);
  }
}
