/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilité déportées      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/
package com.ael.util;

public class Periode {
	
	private long debut;
	private long fin;
	
	/**
	 * Construit une <code>Periode</code> avec ses paramètres
	 * 
	 * @param d	valeur du début de période en ms
	 * @param f valeur de fin de période en ms
	 */
	public Periode(long d, long f) {
		this.debut = d;
		this.fin = f;
	}
	
	/**
	 * Construit une <code>Periode</code> paramétré à 0 donc au début de epoch
	 * avec un début et une fin équivalentes
	 */
	public Periode() {
		this(0, 0);
	}

	public long getDebut() {
		return debut;
	}

	public long getFin() {
		return fin;
	}

	public void setDebut(long debut) {
		this.debut = debut;
	}

	public void setFin(long fin) {
		this.fin = fin;
	}
	
}
